## CORBA Interface IOptionService

A service that sets and gets option values for a SAS Workspace.

### Definition

CORBA Module SAS

### IOptionService Description

The component provides an interface for reading and setting option values on the SAS Workspace.

CORBA Definitions
enum SetError | Error and warning classification for setting an option.
enum GetError | Error and warning classification for getting an option value.
enum DataType | The data type of an option value.
attribute Parent | The parent of this component.
method SetOptions | Sets multiple SAS system options to new values.
method GetOptions | Get the values of multiple SAS system options.

Java Classes
IOptionServiceHelper | Used to manipulate the IOptionService type
IOptionServiceHolder | Used to process the IOptionService type as an out parameter
SetError | Error and warning classification for setting an option.
SetErrorHelper | Used to manipulate the SetError type
SetErrorHolder | Used to process the SetError type as an out parameter
SetErrorSeqHelper | Used to manipulate one dimensional arrays of the SetError type
SetErrorSeqHolder | Used to process one dimensional arrays of the SetError type as an out parameter
VariableArray2dOfSetErrorHelper | Used to manipulate two dimensional arrays of the SetError type
VariableArray2dOfSetErrorHolder | Used to process two dimensional arrays of the SetError type
GetError | Error and warning classification for getting an option value.
GetErrorHelper | Used to manipulate the GetError type
GetErrorHolder | Used to process the GetError type as an out parameter
GetErrorSeqHelper | Used to manipulate one dimensional arrays of the GetError type
GetErrorSeqHolder | Used to process one dimensional arrays of the GetError type as an out parameter
VariableArray2dOfGetErrorHelper | Used to manipulate two dimensional arrays of the GetError type
VariableArray2dOfGetErrorHolder | Used to process two dimensional arrays of the GetError type
DataType | The data type of an option value.
DataTypeHelper | Used to manipulate the DataType type
DataTypeHolder | Used to process the DataType type as an out parameter
DataTypeSeqHelper | Used to manipulate one dimensional arrays of the DataType type
DataTypeSeqHolder | Used to process one dimensional arrays of the DataType type as an out parameter
VariableArray2dOfDataTypeHelper | Used to manipulate two dimensional arrays of the DataType type
VariableArray2dOfDataTypeHolder | Used to process two dimensional arrays of the DataType type

Java Interfaces
IOptionService | A service that sets and gets option values for a SAS Workspace.

Java Interface IOptionService

A service that sets and gets option values for a SAS Workspace.

Package com.sas.iom.SAS

IOptionService Description
The component provides an interface for reading and setting option values on the SAS Workspace.

`public interface IOptionService
extends org.omg.CORBA.Object`

Method Summary

void | SetOptions ( java.lang.String[] optionNames , java.lang.String[] values , IntSeqHolder errorIndices , SetErrorSeqHolder errorCodes , StringSeqHolder errorMsgs ) throws ( GenericError ); Sets multiple SAS system options to new values.
void | GetOptions ( java.lang.String[] optionNames , DataTypeSeqHolder types , BooleanSeqHolder isPortable , BooleanSeqHolder isStartupOnly , StringSeqHolder values , IntSeqHolder errorIndices , GetErrorSeqHolder errorCodes , StringSeqHolder errorMsgs ) throws ( GenericError ); Get the values of multiple SAS system options.

Java Class IOptionServiceHelper

public class IOptionServiceHelper

Description
Implementing class for methods (insert, extract, type, id, read, write, narrow) used to manipulate the IOptionService type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionServiceHelper

Java Class IOptionServiceHolder

public class IOptionServiceHolder

Description
Implementing class for methods (_read, _write, _type) used to process the IOptionService type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionServiceHolder

CORBA Enum SetError

Error and warning classification for setting an option.

Description
The OptionService component provides a SetOptions operation that sets multiple options at once. It classifies option setting problems according to the set of values described here.

Usage

Member | Description
--- | ---
SetErrorNone | Option set successfully, but a warning message was generated.
SetErrorUnknown | The option was not set due to an error of unknown type. See the accompanying message for details.
SetErrorInvalidName | The specified option name is not known.
SetErrorInvalidValue | The specified option value is not correct. See the accompanying message for details.
SetErrorNotSettable | The specified option cannot be set after SAS invocation.

Java Class SetError

public class SetError

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.SetError

Java Class SetErrorHelper

public class SetErrorHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate the SetError type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.SetErrorHelper

Java Class SetErrorHolder

public class SetErrorHolder

Description
Implementing class for methods (_read, _write, _type) used to process the SetError type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.SetErrorHolder

Java Class SetErrorSeqHelper

public class SetErrorSeqHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate singly dimensioned arrays of SetError type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.SetErrorSeqHelper

Java Class SetErrorSeqHolder

public class SetErrorSeqHolder

Description
Implementing class for methods (_read, _write, _type) used to process singly dimensioned arrays of the SetError type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.SetErrorSeqHolder

Java Class VariableArray2dOfSetErrorHelper

public class VariableArray2dOfSetErrorHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate doubly dimensioned arrays of SetError type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.VariableArray2dOfSetErrorHelper

Java Class VariableArray2dOfSetErrorHolder

public class VariableArray2dOfSetErrorHolder

Description
Implementing class for methods (_read, _write, _type) used to process doubly dimensioned arrays of the SetError type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.VariableArray2dOfSetErrorHolder

CORBA Enum GetError

Error and warning classification for getting an option value.

Description
The OptionService component provides a GetOptions operation that gets multiple options at once. It classifies option query problems according to the set of values described here.

Usage

Member | Description
--- | ---
GetErrorNone | Option information was obtained successfully, but a warning message was generated.
GetErrorUnknown | The option value was not retrieved due to an error of unknown type. See the accompanying message for details.
GetErrorInvalidName | The specified option name is not known.

Java Class GetError

public class GetError

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.GetError

Java Class GetErrorHelper

public class GetErrorHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate the GetError type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.GetErrorHelper

Java Class GetErrorHolder

public class GetErrorHolder

Description
Implementing class for methods (_read, _write, _type) used to process the GetError type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.GetErrorHolder

Java Class GetErrorSeqHelper

public class GetErrorSeqHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate singly dimensioned arrays of GetError type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.GetErrorSeqHelper

Java Class GetErrorSeqHolder

public class GetErrorSeqHolder

Description
Implementing class for methods (_read, _write, _type) used to process singly dimensioned arrays of the GetError type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.GetErrorSeqHolder

Java Class VariableArray2dOfGetErrorHelper

public class VariableArray2dOfGetErrorHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate doubly dimensioned arrays of GetError type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.VariableArray2dOfGetErrorHelper

Java Class VariableArray2dOfGetErrorHolder

public class VariableArray2dOfGetErrorHolder

Description
Implementing class for methods (_read, _write, _type) used to process doubly dimensioned arrays of the GetError type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.VariableArray2dOfGetErrorHolder

CORBA Enum DataType

The data type of an option value.

Description
This enumeration identifies the possible data types for option values.

Usage

Member | Description
--- | ---
DataTypeString | The option value is a string.
DataTypeBoolean | The option value is Boolean (true/false).
DataTypeInteger | The option value is an integer.
DataTypeDouble | The option value is a real number (SAS numeric value) that can be represented in double-precision floating-point format.

Java Class DataType

public class DataType

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.DataType

Java Class DataTypeHelper

public class DataTypeHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate the DataType type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.DataTypeHelper

Java Class DataTypeHolder

public class DataTypeHolder

Description
Implementing class for methods (_read, _write, _type) used to process the DataType type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.DataTypeHolder

Java Class DataTypeSeqHelper

public class DataTypeSeqHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate singly dimensioned arrays of DataType type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.DataTypeSeqHelper

Java Class DataTypeSeqHolder

public class DataTypeSeqHolder

Description
Implementing class for methods (_read, _write, _type) used to process singly dimensioned arrays of the DataType type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.DataTypeSeqHolder

Java Class VariableArray2dOfDataTypeHelper

public class VariableArray2dOfDataTypeHelper

Description
Implementing class for methods (insert, extract, type, id, read, write) used to manipulate doubly dimensioned arrays of DataType type.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.VariableArray2dOfDataTypeHelper

Java Class VariableArray2dOfDataTypeHolder

public class VariableArray2dOfDataTypeHolder

Description
Implementing class for methods (_read, _write, _type) used to process doubly dimensioned arrays of the DataType type as an out parameter.

    java.lang.Object
      |
      +--com.sas.iom.SAS.IOptionService_1_0Package.VariableArray2dOfDataTypeHolder

CORBA Attribute Parent (readonly)

The parent of this component.

Description
The Utilities component that is the parent of this component.

Usage

Java Method Parent

    public IUtilities Parent ();

CORBA Method SetOptions

Sets multiple SAS system options to new values.

Description
Call SetOptions to set one or more SAS system options to new values. This operation accepts input array parameters that supply the option name and new value for each option. These two arrays must be of equal size.

Errors and warnings are returned using three arrays, all of which have a size equal to the total number of errors and warnings encountered (often zero). The first of these identifies which options had problems by listing indices from the option name input array. The second returns an error type indicator for each. The third returns a message describing each error or warning.

Usage

Java Method SetOptions

`void` SetOptions (

        java.lang.String[] optionNames ,
        java.lang.String[] values ,
        IntSeqHolder errorIndices ,
        SetErrorSeqHolder errorCodes ,
        StringSeqHolder errorMsgs
        )
        throws (
                GenericError
        );

Parameter Details

Parameter | Direction | Type | Description
--- | --- | --- | ---
optionNames | in | java.lang.String[] | A one-dimensional array of strings that names the SAS system options to be set. If you want to set only one option, then the array should contain only one element. For Boolean options, it is also possible to supply the negative form of the option name. See the description of the following parameter (SetOptions::values) for details.
values | in | java.lang.String[] | An array of strings containing the values for the options. This array must be the same size as the one that specifies option names. A string is used regardless of the data type of the option. For options whose values are not already strings, the string is converted to the value of the appropriate type for the option. For numeric values, this is easy. Special rules apply for Boolean options. They may be set via the option name alone (in positive or negative form) or via the positive option name with the value specified as the name in positive or negative form. Here are the possible alternatives (using the FMTERR option as an example):
     || Name      || Value      || Setting
     || FMTERR    ||            || On
     || NOFMTERR  ||            || Off
     || FMTERR    || FMTERR     || On
     || FMTERR    || NOFMTERR   || Off
errorIndices | out | IntSeqHolder | An array which identifies individual errors or warnings by listing their indices from the input arrays. If the returned array is zero-length, then no errors or warnings occurred while setting the options.
errorCodes | out | SetErrorSeqHolder | For each error or warning identified in the previous parameter (SetOptions::errorIndices), the corresponding element in this array distinguishes error from warning and identifies the type of error by returning a value from the SetError enumeration.
errorMsgs | out | StringSeqHolder | Provides an error (or warning) message for each item listed in the SetOptions::errorIndices output parameter.

Example

CORBA Method GetOptions

Get the values of multiple SAS system options.

Description
Get the values of multiple SAS system options for the Workspace. Information about the option is also returned.

Usage

Java Method GetOptions

`void` GetOptions (

        java.lang.String[] optionNames ,
        DataTypeSeqHolder types ,
        BooleanSeqHolder isPortable ,
        BooleanSeqHolder isStartupOnly ,
        StringSeqHolder values ,
        IntSeqHolder errorIndices ,
        GetErrorSeqHolder errorCodes ,
        StringSeqHolder errorMsgs
        )
        throws (
                GenericError
        );

Parameter Details

Parameter | Direction | Type | Description
--- | --- | --- | ---
optionNames | in | java.lang.String[] | A one-dimensional array of strings that name the SAS system options to be retrieved. If you want to retrieve only one option, then the array should contain only one element. For Boolean options, the name must be the base option name. The "NO" form cannot be used in this parameter.
types | out | DataTypeSeqHolder | The data type of each option as indicated by the DataType enumeration.
isPortable | out | BooleanSeqHolder | Distinguishes portable and host options.
isStartupOnly | out | BooleanSeqHolder | Indicates if an option is restricted to being set only when starting SAS.
values | out | StringSeqHolder | An array of strings that returns the value of each of the requested options. This array is the same size as the input array of option names. A string is used regardless of the data type of the option. For options whose values are not strings, you can convert the string to the appropriate type. Boolean options are treated differently. The positive or negative form of the option name will be returned. The following table shows an example of this with the FMTERR option:
     || Name      || Setting    || Returned value
     || FMTERR    || On         || FMTERR
     || FMTERR    || Off        || NOFMTERR
errorIndices | out | IntSeqHolder | An array which identifies individual errors or warnings by listing their indices from the input array. The GetOptions::types, GetOptions::isPortable, GetOptions::isStartupOnly and GetOptions::values output parameters will have an element for each option request regardless of whether or not it had an error. The elements, however, contain meaningful values only when an error does not occur. If the returned array is zero-length, then there were no errors or warnings in retrieving the options.
errorCodes | out | GetErrorSeqHolder | For each error or warning identified in the previous parameter (GetOptions::errorIndices), the corresponding element in this array distinguishes error from warning and identifies the type of error by returning a value from the GetError enumeration.
errorMsgs | out | StringSeqHolder | Provides an error (or warning) message for each item listed in the GetOptions::errorIndices output parameter.

Example